#include "windows.h"
#include "mapmem.h"

int _tmain(int argc, _TCHAR* argv[])
{
	// Init map mem lib
	HANDLE maphandle=Map_Init();

	// we need to map the OCOTPANA1 fuse to read calibration values
	volatile DWORD* ocotpana1;

	ocotpana1=(DWORD*)Map_MapMemory(0x021BC4E0,sizeof(DWORD));

	// split the value into room temperature (25C) value, hot value and hot reference temp
	DWORD roomcount,hotcount,hottemp;

	roomcount=*ocotpana1>>20;
	hotcount=(*ocotpana1>>8)&0x00000FFF;
	hottemp=*ocotpana1&0x000000FF;

	// map the TEMPMON registers (TEMPSENSE0 and TEMPSENSE1, both have separate registers to set,clear and toggle bits)
	volatile DWORD *tempsense0,*tempsense1;
	volatile DWORD *tempsense0set,*tempsense0clr,*tempsense0tog;
	volatile DWORD *tempsense1set,*tempsense1clr,*tempsense1tog;

	tempsense0=(DWORD*)Map_MapMemory(0x020C8180,8*sizeof(DWORD));
	tempsense0set=tempsense0+1;
	tempsense0clr=tempsense0+2;
	tempsense0tog=tempsense0+3;

	tempsense1=tempsense0+4;
	tempsense1set=tempsense1+1;
	tempsense1clr=tempsense1+2;
	tempsense1tog=tempsense1+3;

	// disable auto updates
	*tempsense1clr=0xFFFFFFFF;

	//set alarm to max value (we are not using the interrupt)
	*tempsense0set=0xFFF00000;

	// power-on sensor
	*tempsense0clr=0x00000001;

	// measure
	for (;;)
	{
		// clears start flag
		*tempsense0clr=0x00000002;

		_tprintf(TEXT("%08x\r\n"),*tempsense0);

		// start
		*tempsense0set=0x00000002;
		Sleep(1);

		// wait until measured value is valid
		while (!(*tempsense0 & 0x00000004))
			Sleep(1);

		_tprintf(TEXT("%08x\r\n"),*tempsense0);

		// calculate temperature in Celsius
		DWORD tempcount=(*tempsense0 >> 8) & 0x00000FFF;
		DWORD tmeas=(DWORD)((double)hottemp-(tempcount-hotcount)*((hottemp-25.0)/(roomcount-hotcount)));

		// print it out
		_tprintf(TEXT("Temperature: %d\r\n"),tmeas);
		RETAILMSG(1,(TEXT("Temperature: %d\r\n"),tmeas));

		// wait a minute before doing a new measurement
		Sleep(1000);
	}
	return 0;
}